
package de.ivu.elect.presentation.stimmeingabe.action;

import javax.annotation.Nonnull;
import javax.inject.Inject;
import javax.inject.Named;

import de.ivu.elect.business.gebietsbaum.boundary.GebietSessionSelect;
import de.ivu.elect.business.gebietsbaum.entity.Wahldurchfuehrungsgebiet;
import de.ivu.elect.business.security.UseCasePermission;
import de.ivu.elect.business.stimmeingabe.entity.Ergebniseingang;
import de.ivu.elect.presentation.stimmeingabe.StimmeingabeErfassenViewResolver;

@Named(ErgebniseingangEditAction.COMPONENT_NAME)
public class ErgebniseingangEditAction extends AbstractErgebniseingangAction {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "ergebniseingangEditAction";

  @Inject
  private transient GebietSessionSelect gebietSessionSelect;

  @Inject
  private transient StimmeingabeErfassenViewResolver stimmeingabeErfassenViewResolver;

  public ErgebniseingangEditAction() {
    super();
  }

  @Override
  protected UseCasePermission getRequiredPermission() {
    return stimmeingabeErfassenViewResolver.getViewIdPermission();
  }

  @Override
  public boolean isDisabledInternal(@Nonnull Ergebniseingang ergebniseingang) {
    return false;
  }

  @Override
  protected String doIt(Ergebniseingang ergebniseingang) {
    if (ergebniseingang == null) {
      return null;
    }

    Wahldurchfuehrungsgebiet wahldurchfuehrungsgebiet = ergebniseingang.getWahldurchfuehrungsgebiet();

    if (wahldurchfuehrungsgebiet == null) {
      return null;
    }

    gebietSessionSelect.setEntity(wahldurchfuehrungsgebiet);

    return stimmeingabeErfassenViewResolver.getViewId();
  }

  @Override
  public String getLabelKey() {
    return "stimmeingabe.erfassen.menu.item.label";
  }

  @Override
  public String getIcon() {
    return appIcons.getIconEdit();
  }
}
